// Generated by CoffeeScript 1.10.0
(function() {
  var CND, alert, append, as_number, as_numbers, badge, debug, echo, fuse, help, info, log, meld, mix, normalize_points, normalize_tag, reduce_tag, rpr, setting_keys_of_cover_and_intersect, sort_entries_by_insertion_order, sort_ids_by_insertion_order, unique, urge, warn, whisper, σ_minus_א, σ_misfit, σ_plus_א,
    slice = [].slice;

  CND = require('cnd');

  rpr = CND.rpr.bind(CND);

  badge = 'INTERSKIPLIST';

  log = CND.get_logger('plain', badge);

  info = CND.get_logger('info', badge);

  whisper = CND.get_logger('whisper', badge);

  alert = CND.get_logger('alert', badge);

  debug = CND.get_logger('debug', badge);

  warn = CND.get_logger('warn', badge);

  help = CND.get_logger('help', badge);

  urge = CND.get_logger('urge', badge);

  echo = CND.echo.bind(CND);

  σ_plus_א = Symbol["for"]('+א');

  σ_minus_א = Symbol["for"]('-א');

  σ_misfit = Symbol["for"]('misfit');

  mix = require('multimix').mix;

  this["new"] = function(settings) {
    var R, isl_settings, substrate;
    if (settings != null) {
      throw new Error("settings not supported");
    }
    isl_settings = {
      minIndex: σ_minus_א,
      maxIndex: σ_plus_א,
      compare: function(a, b) {
        if (a === b && (a === σ_plus_א || a === σ_minus_א)) {
          return 0;
        }
        if ((a === σ_plus_א) || (b === σ_minus_א)) {
          return +1;
        }
        if ((a === σ_minus_א) || (b === σ_plus_א)) {
          return -1;
        }
        if (a > b) {
          return +1;
        }
        if (a < b) {
          return -1;
        }
        return 0;
      }
    };
    substrate = new (require('interval-skip-list'))(isl_settings);
    substrate.toString = substrate.inspect = function() {
      return "{ interval-skip-list }";
    };
    R = {
      '~isa': 'CND/interskiplist',
      '%self': substrate,
      'entry-by-ids': {},
      'idx-by-names': {},
      'ids-by-names': {},
      'name-by-ids': {},
      'idx-by-ids': {},
      'ids': [],
      'idx': -1,
      'min': null,
      'max': null,
      'fmin': null,
      'fmax': null,
      'indexes': {}
    };
    return R;
  };

  this.copy = function(me) {
    var R, entry, i, len, name, ref;
    R = this["new"]();
    for (name in me['indexes']) {
      this.add_index(R, name);
    }
    ref = this.entries_of(me);
    for (i = 0, len = ref.length; i < len; i++) {
      entry = ref[i];
      this.add(R, CND.deep_copy(entry));
    }
    return R;
  };

  this.add = function(me, entry) {

    /* TAINT currently we keep the identity of `entry` and amend it; wouldn't it be better to copy? or deep
    copy? it and then amend it?
     */
    var arity, base, global_idx, group_idx, hi, id, lo, name, ref;
    if ((arity = arguments.length) !== 2) {
      throw new Error("expected 2 arguments, got " + arity);
    }
    if (!CND.isa_pod(entry)) {
      throw new Error("expected a POD, got a " + (CND.type_of(entry)));
    }
    lo = entry.lo, hi = entry.hi, id = entry.id, name = entry.name;
    if (lo == null) {
      throw new Error("expected setting for 'lo', found none");
    }
    if (hi == null) {
      throw new Error("expected setting for 'hi', found none");
    }
    lo = as_number(lo);
    hi = as_number(hi);
    if (name == null) {
      name = '+';
    }
    group_idx = (me['idx-by-names'][name] = ((ref = me['idx-by-names'][name]) != null ? ref : -1) + 1);
    global_idx = (me['idx'] += +1);
    if (id == null) {
      id = name + "[" + group_idx + "]";
    }
    entry['lo'] = lo;
    entry['hi'] = hi;
    entry['idx'] = global_idx;
    entry['id'] = id;
    entry['name'] = name;
    entry['size'] = hi - lo + 1;
    if (entry['tag'] != null) {
      entry['tag'] = normalize_tag(entry['tag']);
    }
    if (me['min'] == null) {
      me['min'] = lo;
    }
    me['min'] = Math.min(me['min'], lo);
    if (me['max'] == null) {
      me['max'] = hi;
    }
    me['max'] = Math.max(me['max'], lo);
    if (CND.isa_number(lo)) {
      if (me['fmin'] == null) {
        me['fmin'] = lo;
      }
      me['fmin'] = Math.min(me['fmin'], lo);
    }
    if (CND.isa_number(hi)) {
      if (me['fmax'] == null) {
        me['fmax'] = hi;
      }
      me['fmax'] = Math.max(me['fmax'], lo);
    }
    me['name-by-ids'][id] = name;
    me['idx-by-ids'][id] = global_idx;
    me['entry-by-ids'][id] = entry != null ? entry : null;
    ((base = me['ids-by-names'])[name] != null ? base[name] : base[name] = []).push(id);
    me['%self'].insert(id, lo, hi);
    me['ids'].push(id);
    this._index_entry(me, entry);
    return id;
  };

  this["delete"] = function(me, id) {
    return me['%self'].remove(id);
  };

  this.to_xjson = function(me) {
    var R, _, entry, key;
    R = {
      'index-keys': (function() {
        var results;
        results = [];
        for (key in me['indexes']) {
          results.push(key);
        }
        return results;
      })(),
      'entries': (function() {
        var ref, results;
        ref = me['entry-by-ids'];
        results = [];
        for (_ in ref) {
          entry = ref[_];
          results.push(entry);
        }
        return results;
      })()
    };
    return CND.XJSON.stringify(R, null, '  ');
  };

  this.new_from_xjson = function(xjson) {
    var R, description, entry, i, j, key, len, len1, ref, ref1;
    description = CND.XJSON.parse(xjson);
    R = this["new"]();
    ref = description['index-keys'];
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      this.add_index(R, key);
    }
    ref1 = description['entries'];
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      entry = ref1[j];
      this.add(R, entry);
    }
    return R;
  };

  this.add_index = function(me, name) {
    if (me['indexes'][name] != null) {
      throw new Error("index for " + (rpr(name)) + " already exists");
    }
    return me['indexes'][name] = {};
  };

  this.delete_index = function(me, name, fallback) {
    var R, ref;
    if (fallback === void 0) {
      fallback = σ_misfit;
    }
    R = (ref = me['indexes'][name]) != null ? ref : fallback;
    if (R === σ_misfit) {
      throw new Error("no index for field " + (rpr(name)));
    }
    delete me['indexes'][name];
    return R;
  };

  this.find_ids = function(me, name, value) {
    var R, index;
    if ((index = me['indexes'][name]) == null) {
      throw new Error("no index for field " + (rpr(name)));
    }
    if ((R = index[value]) == null) {
      return [];
    }
    return Object.assign([], R);
  };

  this.find_entries = function(me, name, value) {
    var R, i, id, idx, len;
    R = this.find_ids(me, name, value);
    for (idx = i = 0, len = R.length; i < len; idx = ++i) {
      id = R[idx];
      R[idx] = me['entry-by-ids'][id];
    }
    return R;
  };

  this._index_entry = function(me, entry) {
    var i, id, index, indexes, len, name, ref, tag, value;
    id = entry.id;
    if ((indexes = me['indexes']) != null) {
      for (name in entry) {
        value = entry[name];
        if (!(index = indexes[name])) {
          continue;
        }

        /* TAINT this is a minimally viable product; indexing behavior should be configurable */
        if (name === 'tag') {
          ref = normalize_tag(value);
          for (i = 0, len = ref.length; i < len; i++) {
            tag = ref[i];
            (index[tag] != null ? index[tag] : index[tag] = []).push(id);
          }
        } else {
          (index[value] != null ? index[value] : index[value] = []).push(id);
        }
      }
    }
    return null;
  };

  this.match = function(me, points, settings) {
    if (settings == null) {
      settings = {};
    }
    return this._match_or_intersect(me, 'match', points, settings);
  };

  this.intersect = function(me, points, settings) {
    if (settings == null) {
      settings = {};
    }
    return this._match_or_intersect(me, 'intersect', points, settings);
  };

  this._match_or_intersect = function(me, mode, points, settings) {
    throw new Error("ISL.match, ISL.intersect on hold for revision");
  };

  setting_keys_of_cover_and_intersect = ['pick'];

  this.entries_of = function(me, ids) {
    var R, _, entry, i, id, len;
    if (ids == null) {
      ids = null;
    }
    if (ids == null) {
      R = (function() {
        var ref, results;
        ref = me['entry-by-ids'];
        results = [];
        for (_ in ref) {
          entry = ref[_];
          results.push(entry);
        }
        return results;
      })();
    } else {
      R = [];
      for (i = 0, len = ids.length; i < len; i++) {
        id = ids[i];
        if ((entry = me['entry-by-ids'][id]) == null) {
          throw new Error("unknown ID " + (rpr(id)));
        }
        R.push(entry);
      }
    }
    return sort_entries_by_insertion_order(me, R);
  };

  this._find_ids_with_any_points = function(me, points) {
    var R, i, id, ids, j, len, len1, point, ref;
    points = normalize_points(points);
    if (points.length < 2) {
      return (ref = me['%self']).findContaining.apply(ref, points);
    }
    R = new Set();
    for (i = 0, len = points.length; i < len; i++) {
      point = points[i];
      ids = me['%self'].findContaining(point);
      for (j = 0, len1 = ids.length; j < len1; j++) {
        id = ids[j];
        R.add(id);
      }
    }
    return sort_ids_by_insertion_order(me, Array.from(R));
  };

  this._find_ids_with_all_points = function(me, points) {
    var ref;
    points = normalize_points(points);
    return (ref = me['%self']).findContaining.apply(ref, points);
  };

  this.intervals_from_points = function() {
    var R, i, last_hi, last_lo, last_point, len, me, mixin, mixins, point, points;
    me = arguments[0], points = arguments[1], mixins = 3 <= arguments.length ? slice.call(arguments, 2) : [];
    mixin = function(lohi) {
      if (!(mixins.length > 0)) {
        return lohi;
      }
      return Object.assign.apply(Object, [{}].concat(slice.call(mixins), [lohi]));
    };
    if (!CND.isa_list(points)) {
      points = [points];
    }
    points = unique(as_numbers(points));
    points.sort(function(a, b) {
      if (a > b) {
        return +1;
      }
      if (a < b) {
        return -1;
      }
      return 0;
    });
    R = [];
    last_point = null;
    last_lo = null;
    last_hi = null;
    for (i = 0, len = points.length; i < len; i++) {
      point = points[i];
      if (last_lo == null) {
        last_lo = point;
        last_hi = point;
        last_point = point;
        continue;
      }
      if (point === last_point + 1) {
        last_hi = point;
        last_point = point;
        continue;
      }
      R.push(mixin({
        lo: last_lo,
        hi: last_hi
      }));
      last_lo = point;
      last_hi = point;
      last_point = point;
    }
    if ((last_lo != null) && (last_hi != null)) {
      R.push(mixin({
        lo: last_lo,
        hi: last_hi
      }));
    }
    return R;
  };

  this.aggregate = function(me, point, reducers) {
    if (reducers == null) {
      reducers = null;
    }
    return (this.aggregate.use(me, reducers))(point);
  };

  this.aggregate.use = (function(_this) {
    return function(me, reducers, settings) {
      var cache, keys, memoize, mix_entries_of_point, mixins, ref;
      if (settings == null) {
        settings = {};
      }
      if (!CND.is_subset((keys = Object.keys(settings)), ['memoize'])) {
        throw new Error("unknown keys in " + (rpr(keys)));
      }
      if ((memoize = (ref = settings['memoize']) != null ? ref : true)) {
        cache = {};
      } else {
        cache = null;
      }
      if ((reducers == null) || (Object.keys(reducers)).length === 0) {
        mix = _this.aggregate._mix;
      } else {
        mixins = [{}];
        mixins.push(_this.aggregate._reducers);
        if (reducers != null) {
          mixins.push(reducers);
        }
        reducers = Object.assign.apply(Object, mixins);
        mix = mix.use(reducers);
      }
      mix_entries_of_point = function(point) {
        var entries, point_count;
        point_count = CND.isa_list(point) ? point.length : 1;
        if (point_count !== 1) {
          throw new Error("need single point, got " + point_count);
        }
        entries = _this.entries_of(me, _this._find_ids_with_any_points(me, point));
        return mix.apply(null, entries);
      };
      if (!memoize) {
        return mix_entries_of_point;
      }
      return function(point) {
        var R;
        if ((R = cache[point]) != null) {
          return R;
        }
        return cache[point] = mix_entries_of_point(point);
      };
    };
  })(this);

  this.aggregate._reducers = {
    idx: 'skip',
    id: 'skip',
    name: 'skip',
    lo: 'skip',
    hi: 'skip',
    size: 'skip',
    tag: 'tag'
  };

  this.aggregate._mix = mix.use(this.aggregate._reducers);

  sort_entries_by_insertion_order = function(me, entries) {
    entries.sort(function(a, b) {
      if (a['idx'] > b['idx']) {
        return +1;
      }
      if (a['idx'] < b['idx']) {
        return -1;
      }
      return 0;
    });
    return entries;
  };

  sort_ids_by_insertion_order = function(me, ids) {
    var idxs;
    idxs = me['idx-by-ids'];
    ids.sort(function(a, b) {
      if (idxs[a] > idxs[b]) {
        return +1;
      }
      if (idxs[a] < idxs[b]) {
        return -1;
      }
      return 0;
    });
    return ids;
  };

  as_number = function(x) {
    var length, type;
    if ((x === (-Infinity) || x === (+Infinity)) || CND.isa_number(x)) {
      return x;
    }
    if ((type = CND.type_of(x)) !== 'text') {
      throw new Error("expected number or single character text, got a " + type);
    }
    if ((length = (Array.from(x)).length) !== 1) {
      throw new Error("expected single character text, got one of length " + length);
    }
    return x.codePointAt(0);
  };

  as_numbers = function(list) {
    var i, len, results, x;
    results = [];
    for (i = 0, len = list.length; i < len; i++) {
      x = list[i];
      results.push(as_number(x));
    }
    return results;
  };

  normalize_points = function(points) {
    if (!CND.isa_list(points)) {
      points = [points];
    }
    return as_numbers(points);
  };

  normalize_tag = function(tag) {

    /* Given a single string or a list of strings, return a new list that contains all whitespace-delimited
    words in the strings
     */
    var R, i, len, t;
    if (!CND.isa_list(tag)) {
      return normalize_tag([tag]);
    }
    R = [];
    for (i = 0, len = tag.length; i < len; i++) {
      t = tag[i];
      if (t.length === 0) {
        continue;
      }
      R.splice.apply(R, [R.length, 0].concat(slice.call(t.split(/\s+/))));
    }

    /* TAINT consider to return `unique R` instead */
    return R;
  };

  unique = function(list) {

    /* Return a copy of `list´ that only contains the last occurrence of each value */

    /* TAINT consider to modify, not copy `list` */
    var R, element, i, idx, ref, seen;
    seen = new Set();
    R = [];
    for (idx = i = ref = list.length - 1; i >= 0; idx = i += -1) {
      element = list[idx];
      if (seen.has(element)) {
        continue;
      }
      seen.add(element);
      R.unshift(element);
    }
    return R;
  };

  append = function(a, b) {

    /* Append elements of list `b` to list `a` */

    /* TAINT JS has `[]::concat` */
    a.splice.apply(a, [a.length, 0].concat(slice.call(b)));
    return a;
  };

  meld = function(list, value) {

    /* When `value` is a list, `append` it to `list`; else, `push` `value` to `list` */
    if (CND.isa_list(value)) {
      append(list, value);
    } else {
      list.push(value);
    }
    return list;
  };

  fuse = function(list) {

    /* Flatten `list`, then apply `unique` to it. Does not copy `list` but modifies it */
    var R, element, i, len;
    R = [];
    for (i = 0, len = list.length; i < len; i++) {
      element = list[i];
      meld(R, element);
    }
    R = unique(R);
    list.splice.apply(list, [0, list.length].concat(slice.call(R)));
    return list;
  };

  reduce_tag = function(raw) {
    var R, exclude, i, idx, ref, source, tag;
    source = fuse(raw);
    R = [];
    exclude = null;
    for (idx = i = ref = source.length - 1; i >= 0; idx = i += -1) {
      tag = source[idx];
      if ((exclude != null) && exclude.has(tag)) {
        continue;
      }
      if (tag.startsWith('-')) {
        if (tag === '-*') {
          break;
        }
        (exclude != null ? exclude : exclude = new Set()).add(tag.slice(1));
        continue;
      }
      R.unshift(tag);
    }
    return R;
  };

}).call(this);

//# sourceMappingURL=main.js.map
